{ demoStepperDD100606d.spin

  stepper motor driver.  Started July 11, 2009
  Version 090712a drives motor clockwise continuously.  Version c made from a (abadon b).
  Start making this diver more versital.
  demoStepperDD090712e works!
  Verson 100606c, I want to add a global variable that keeps track of total steps.
  

' Connections (for L293D DIP):
' --------------------------------------
' P0 -> L293D.1 and L293D.9
' P1 -> L293D.2, L293D.3   -> Pin A on motor (far left)
' P2 -> L293D.15, L293D.14 -> Pin B on motor (fourth from left)
' P3 -> L293D.7, L293D.6   -> Pin C on motor (third from left)
' P4 -> L293D.10, L293D.11 -> Pin D on motor (far right)
}

CON

  _CLKMODE = XTAL1 + PLL16X                            ' this should be in top object
  _XINFREQ = 5_000_000


  '_MinimumStepDelay   = 5                                     ' minimum step time  3
  _StepsPerRev = 200
  _FirstPin = 0
  _ClockWise = 0
  _CounterClockWise = 1

OBJ

  Stepper : "stepperDD100606c"
  Debug: "FullDuplexSerial"


VAR

  long globalSteps
  byte intructionAcceptedFlag

  'long  stepperStack[64], stepsPerRev, stepCounter, stepPattern



PUB Main

  Debug.start(31, 30, 0, 9600)

  Stepper.Start(_FirstPin, _StepsPerRev, @globalSteps)
  waitcnt(clkfreq/6 + cnt)
  intructionAcceptedFlag := 0
  globalSteps := 0              ' if needed this could be saved in EEPROM
  Stepper.ChangeDelay(20)
  repeat
    waitcnt(clkfreq/6 + cnt)
    {if ina[8] == 0
      repeat
        intructionAcceptedFlag := Stepper.DriveSteps(1, 0)
      while intructionAcceptedFlag == 0
      Debug.str(string("one step cw"))
      Debug.tx(13)
    elseif ina[9] == 0
      repeat
        intructionAcceptedFlag := Stepper.DriveSteps(1, 1)
      while intructionAcceptedFlag == 0
      Debug.str(string("one step ccw"))
      Debug.tx(13)
    elseif ina[10] == 0
      repeat
        intructionAcceptedFlag := Stepper.DriveSteps((_StepsPerRev / 4), 0)
      while intructionAcceptedFlag == 0
      Debug.str(string("quarter revolution cw"))
      Debug.tx(13)
    elseif ina[11] == 0
      repeat
        intructionAcceptedFlag := Stepper.DriveSteps(_StepsPerRev / 4, 1)
      while intructionAcceptedFlag == 0
      Debug.str(string("quarter revolution ccw")) 
      Debug.tx(13)    
    else}   ' the "if" below was part of this "elseif"
    if ina[12] == 0    ' pin 12 normally held high if button brings pin low it is "on"
      repeat
        intructionAcceptedFlag := Stepper.DriveRevolutions(30, 0)
      while intructionAcceptedFlag == 0
      Debug.str(string("30 full revolution cw")) 
      Debug.tx(13)
    elseif ina[13] == 0
      repeat
        intructionAcceptedFlag := Stepper.DriveRevolutions(30, 1)
      while intructionAcceptedFlag == 0
      Debug.str(string("30 full revolution ccw"))
      Debug.tx(13)
   { elseif ina[14] == 0
      repeat
        intructionAcceptedFlag := Stepper.DriveRevolutions(10, 0)
      while intructionAcceptedFlag == 0
      Debug.str(string("10 revolutions cw"))
      Debug.tx(13)
    elseif ina[15] == 0
      repeat
        intructionAcceptedFlag := Stepper.DriveRevolutions(10, 1)
      while intructionAcceptedFlag == 0
      Debug.str(string("10 revolutions ccw"))
      Debug.tx(13)     }
    else
      Debug.str(string("globalSteps = "))
      Debug.dec(globalSteps)
      Debug.tx(13)

  {
  repeat
    repeat 
      intructionAcceptedFlag := Stepper.DriveRevolutions(6, 1)
    while intructionAcceptedFlag == 0
    
    Debug.str(string("six revs cw"))
    Debug.tx(13)
  
    repeat 
      intructionAcceptedFlag := Stepper.DriveRevolutions(3, 0)
    while intructionAcceptedFlag == 0
    Debug.str(string("three revs ccw"))
    Debug.tx(13)

    repeat 
      intructionAcceptedFlag := Stepper.DriveSteps(200, 0)
    while intructionAcceptedFlag == 0
    Debug.str(string("200 steps cw"))
    Debug.tx(13)
    repeat 
      intructionAcceptedFlag := Stepper.DriveSteps(100, 1)
    while intructionAcceptedFlag == 0
    Debug.str(string("100 steps ccw"))
    Debug.tx(13)
    waitcnt(clkfreq/6 + cnt)    }
    